--- vcl.orig/unx/gtk/gdi/salnativewidgets-gtk.cxx	2010-06-21 12:34:41.000000000 +0100
+++ vcl/unx/gtk/gdi/salnativewidgets-gtk.cxx	2010-06-21 13:19:37.000000000 +0100
@@ -4003,7 +4086,7 @@
         GtkReliefStyle aRelief = GTK_RELIEF_NORMAL;
         gtk_widget_ensure_style( gWidgetData[nScreen].gToolbarWidget );
         gtk_widget_style_get( gWidgetData[nScreen].gToolbarWidget,
-			                  "button_relief", &aRelief,
+                              "button_relief", &aRelief,
                               (char *)NULL);
                               
         gtk_button_set_relief( GTK_BUTTON(gWidgetData[nScreen].gToolbarButtonWidget), aRelief );
@@ -4102,7 +4185,7 @@
     if( !gWidgetData[nScreen].gProgressBar )
     {
         gWidgetData[nScreen].gProgressBar = gtk_progress_bar_new ();
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gProgressBar, nScreen );
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gProgressBar, nScreen );
     }
 }
 
@@ -4111,7 +4194,7 @@
     if( !gWidgetData[nScreen].gTreeView )
     {
         gWidgetData[nScreen].gTreeView = gtk_tree_view_new ();
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gTreeView, nScreen );
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gTreeView, nScreen );
     }
 }
 
@@ -4120,11 +4203,13 @@
     if( !gWidgetData[nScreen].gHScale )
     {
         gWidgetData[nScreen].gHScale = gtk_hscale_new_with_range(0, 10, 1);
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gHScale, nScreen );
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gHScale, nScreen );
     }
     if( !gWidgetData[nScreen].gVScale )
     {
         gWidgetData[nScreen].gVScale = gtk_vscale_new_with_range(0, 10, 1);
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gVScale, nScreen );
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gVScale, nScreen );
     }
 }
+
+/* vi:set tabstop=4 shiftwidth=4 expandtab: */
--- vcl.orig/unx/gtk/window/gtkobject.cxx	2010-05-26 17:30:44.000000000 +0100
+++ vcl/unx/gtk/window/gtkobject.cxx	2010-07-01 10:45:41.000000000 +0100
@@ -32,6 +32,7 @@
 #include <plugins/gtk/gtkframe.hxx>
 #include <plugins/gtk/gtkdata.hxx>
 #include <plugins/gtk/gtkinst.hxx>
+#include <plugins/gtk/gtkgdi.hxx>
 
 GtkSalObject::GtkSalObject( GtkSalFrame* pParent, BOOL bShow ) 
         : m_pSocket( NULL ),
@@ -58,7 +59,7 @@
         SalDisplay* pDisp = GetX11SalData()->GetDisplay();
         m_aSystemData.nSize 		= sizeof( SystemChildData );
         m_aSystemData.pDisplay		= pDisp->GetDisplay();
-        m_aSystemData.aWindow		= GDK_WINDOW_XWINDOW(m_pSocket->window);
+        m_aSystemData.aWindow		= GDK_WINDOW_XWINDOW(widget_get_window(m_pSocket));
         m_aSystemData.pSalFrame		= NULL;
         m_aSystemData.pWidget		= m_pSocket;
         m_aSystemData.pVisual		= pDisp->GetVisual(pParent->getScreenNumber()).GetVisual();
@@ -66,7 +67,7 @@
         m_aSystemData.nDepth		= pDisp->GetVisual(pParent->getScreenNumber()).GetDepth();
         m_aSystemData.aColormap		= pDisp->GetColormap(pParent->getScreenNumber()).GetXColormap();
         m_aSystemData.pAppContext	= NULL;
-        m_aSystemData.aShellWindow	= GDK_WINDOW_XWINDOW(GTK_WIDGET(pParent->getWindow())->window);
+        m_aSystemData.aShellWindow	= GDK_WINDOW_XWINDOW(widget_get_window(GTK_WIDGET(pParent->getWindow())));
         m_aSystemData.pShellWidget	= GTK_WIDGET(pParent->getWindow());
 
         g_signal_connect( G_OBJECT(m_pSocket), "button-press-event", G_CALLBACK(signalButton), this );
--- fpicker.orig/source/unx/gnome/SalGtkPicker.cxx	2010-05-26 17:30:44.000000000 +0100
+++ fpicker/source/unx/gnome/SalGtkPicker.cxx	2010-07-01 12:51:05.000000000 +0100
@@ -155,7 +157,11 @@
     if (pParent)
     {
         gtk_widget_realize(mpDialog);
+#if GTK_CHECK_VERSION(2,90,0)
+        gdk_window_set_transient_for(gtk_widget_get_window(mpDialog), pParent);
+#else
         gdk_window_set_transient_for(mpDialog->window, pParent);
+#endif
     }
 }
 
--- extensions.orig/source/plugin/unx/npnapi.cxx	2010-07-01 13:42:35.000000000 +0100
+++ extensions/source/plugin/unx/npnapi.cxx	2010-07-01 13:44:46.000000000 +0100
@@ -701,8 +701,11 @@
                         pInst->window.window = (void *)gtk_socket_get_id( GTK_SOCKET(pInst->pGtkWidget ) );
 
                         XSync( pAppDisplay, False );
-
+#if GTK_CHECK_VERSION(2,90,0)
+                        XMapWindow( pAppDisplay, GDK_WINDOW_XWINDOW(gtk_widget_get_window(pInst->pGtkWindow)) );
+#else
                         XMapWindow( pAppDisplay, GDK_WINDOW_XWINDOW(pInst->pGtkWindow->window) );
+#endif
 
                         XSync( pAppDisplay, False );
                     }
--- vcl.orig/unx/inc/plugins/gtk/gtkdata.hxx	2010-07-07 10:20:34.000000000 +0100
+++ vcl/unx/inc/plugins/gtk/gtkdata.hxx	2010-07-07 11:15:19.000000000 +0100
@@ -40,6 +40,39 @@
 
 #include <list>
 
+inline GdkWindow * widget_get_window(GtkWidget *widget)
+{
+#if GTK_CHECK_VERSION(2,90,0)
+    return gtk_widget_get_window(widget);
+#else
+    return widget->window;
+#endif
+}
+
+inline void widget_set_can_focus(GtkWidget *widget, gboolean can_focus)
+{
+#if GTK_CHECK_VERSION(2,90,0)
+    return gtk_widget_set_can_focus(widget, can_focus);
+#else
+    if (can_focus)
+        GTK_WIDGET_SET_FLAGS( widget, GTK_CAN_FOCUS );
+    else
+        GTK_WIDGET_UNSET_FLAGS( widget, GTK_CAN_FOCUS );
+#endif
+}
+
+inline void widget_set_can_default(GtkWidget *widget, gboolean can_default)
+{
+#if GTK_CHECK_VERSION(2,90,0)
+    return gtk_widget_set_can_default(widget, can_default);
+#else
+    if (can_default)
+        GTK_WIDGET_SET_FLAGS( widget, GTK_CAN_DEFAULT );
+    else
+        GTK_WIDGET_UNSET_FLAGS( widget, GTK_CAN_DEFAULT );
+#endif
+}
+
 class GtkData : public X11SalData
 {
 public:
@@ -73,6 +106,8 @@
     virtual long Dispatch( XEvent *pEvent );
     virtual void initScreen( int nScreen ) const;
 
+    virtual int GetDefaultMonitorNumber() const;
+
     static GdkFilterReturn filterGdkEvent( GdkXEvent* sys_event,
                                            GdkEvent* event,
                                            gpointer data );
